//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright ""

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DimGray
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    PeriodRSI   = 13;
extern int    PeriodStoch = 10;
extern int    PeriodSK    =  5;
extern int    PeriodSD    =  5;
         //    0 = SMA
         //    1 - EMA
         //    2 - SMMA
         //    3 - LWMA
extern int    MAMode       =   0;
extern int    MinMaxPeriod =  50;
extern double LevelUp      =  80;
extern double LevelDown    =  20;
extern bool   Interpolate  = true;

//
//
//
//
//

double SK[];
double SD[];
double StoRSI[];
double RSI[];
double levelUp[];
double levelMi[];
double levelDn[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,levelUp);
      SetIndexBuffer(1,levelMi);
      SetIndexBuffer(2,levelDn);
      SetIndexBuffer(3,SK);
      SetIndexBuffer(4,SD);
      SetIndexBuffer(5,StoRSI);
      SetIndexBuffer(6,RSI);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" DTOSC ("+PeriodRSI+","+PeriodStoch+","+PeriodSK+","+PeriodSD+")");
return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { levelUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
             
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         RSI[i] = iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,i);
         double LLV = RSI[ArrayMinimum(RSI,PeriodStoch,i)];
         double HHV = RSI[ArrayMaximum(RSI,PeriodStoch,i)];
         if ((HHV-LLV)!=0)
               StoRSI[i] = 100.0*((RSI[i] - LLV)/(HHV - LLV));
         else  StoRSI[i] = 0;
      }   
      for(i=limit; i>=0; i--) SK[i]=iMAOnArray(StoRSI,0,PeriodSK,0,MAMode,i);
      for(i=limit; i>=0; i--)
      {
         SD[i]=iMAOnArray(    SK,0,PeriodSD,0,MAMode,i);
         double skMin = SK[ArrayMinimum(SK,MinMaxPeriod,i)];
         double skMax = SK[ArrayMaximum(SK,MinMaxPeriod,i)];
         double range = skMax-skMin;
               levelUp[i] = skMin+range*LevelDown/100.0;
               levelMi[i] = skMin+range*0.5;
               levelDn[i] = skMin+range*LevelUp/100.0;
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         levelUp[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,MinMaxPeriod,LevelUp,LevelDown,0,y);
         levelMi[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,MinMaxPeriod,LevelUp,LevelDown,1,y);
         levelDn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,MinMaxPeriod,LevelUp,LevelDown,2,y);
         SK[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,MinMaxPeriod,LevelUp,LevelDown,3,y);
         SD[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,MinMaxPeriod,LevelUp,LevelDown,4,y);

         //
         //
         //
         //
         //
      
         if (Interpolate<1 || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
             interpolate(levelUp,timeFrame,i,Interpolate);
             interpolate(levelMi,timeFrame,i,Interpolate);
             interpolate(levelDn,timeFrame,i,Interpolate);
             interpolate(SK     ,timeFrame,i,Interpolate);
             interpolate(SD     ,timeFrame,i,Interpolate);
   }
   return(0);
   
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& target[], int timeFrame, int i, int interpolateType)
{
   int t = iBarShift(NULL,timeFrame,Time[i]); 
      double y0 = target[i];
      double y1 = target[iBarShift(NULL,0,iTime(NULL,timeFrame,t+0))+1];
      double y2 = target[iBarShift(NULL,0,iTime(NULL,timeFrame,t+1))+1];

      //
      //
      //
      //
      //
      
      datetime time = iTime(NULL,timeFrame,t);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
         for(int k = 1; k < n; k++)
         if (interpolateType==2)
         {
            double x3 = 1.0*k/n;
               target[i+k]  = y0*(x3-1.0)*(x3-2.0)/(-1.0*(-2.0))+
                              y1*(x3-0.0)*(x3-2.0)/( 1.0*(-1.0))+
		                        y2*(x3-0.0)*(x3-1.0)/( 2.0*( 1.0));         
         }
         else target[i+k] = target[i] + (target[i+n] - target[i])*k/n;
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}